classification
Title: Improve the doc and indexing of adict.__missing__.
Type: behavior Stage: resolved
Components: Documentation Versions: Python 3.5, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: docs@python Nosy List: docs@python, ethan.furman, python-dev, rhettinger, terry.reedy
Priority: normal Keywords: patch

Created on 2014-12-07 20:49 by terry.reedy, last changed 2014-12-11 00:02 by terry.reedy. This issue is now closed.

Files
File name Uploaded Description Edit
__missing__.diff terry.reedy, 2014-12-07 22:07 initial patch, 3.4 review
Messages (4)
msg232279 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-12-07 20:49
Currently, the only index entry for __missing__ is  "__missing__() (collections.defaultdict method)".  This entry should probably not exist -- see #9536, which inspired this issue.  The method is not mentioned in the special-methods doc, and the explanation in the dict doc is not indexed.  Two suggestions:

https://docs.python.org/3/reference/datamodel.html#emulating-container-types

After __getitem__ entry, add automatically indexed entry, something like 

object.__missing__(self, key):
   When present in a dict subclass, called by dict.__getitem__ for missing keys.

https://docs.python.org/3/library/stdtypes.html#mapping-types-dict

Before the d[key] paragraph starting "If a subclass of dict defines a method __missing__()" add explicit __missing__ index directive.  The last sentence of the paragraph

"See collections.Counter for a complete implementation including other methods helpful for accumulating and managing tallies."

is confusing because the linked entry makes no mention of __missing__ (as it should not).  Change sentence to something like

"There are two stdlib dict subclasses that use (different) __missing__ methods as part of their implementation: collections.Counter and collections.defaultdict."

I will work on a patch and try to get the markup correct.
msg232349 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2014-12-09 08:09
These edits look reasonable, useful and correct.
msg232454 - (view) Author: Roundup Robot (python-dev) Date: 2014-12-10 23:50
New changeset 0fe3fb886c38 by Terry Jan Reedy in branch '2.7':
Issue #23006: Improve the documentation and indexing of dict.__missing__.
https://hg.python.org/cpython/rev/0fe3fb886c38

New changeset 31875b244bdf by Terry Jan Reedy in branch '3.4':
Issue #23006: Improve the documentation and indexing of dict.__missing__.
https://hg.python.org/cpython/rev/31875b244bdf

New changeset 41b172fd4479 by Terry Jan Reedy in branch '3.4':
Issue #23006 whitespace
https://hg.python.org/cpython/rev/41b172fd4479
msg232455 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-12-11 00:02
I made a couple more minor revisions to the 3.4 stdtypes text and copied the revised paragraph, with the code example, to 2.7
History
Date User Action Args
2014-12-11 00:02:50terry.reedysetstatus: open -> closed
resolution: fixed
messages: + msg232455

stage: needs patch -> resolved
2014-12-10 23:50:57python-devsetnosy: + python-dev
messages: + msg232454
2014-12-09 08:09:41rhettingersetnosy: + rhettinger
messages: + msg232349
2014-12-07 22:17:54ethan.furmansetnosy: + ethan.furman
2014-12-07 22:07:33terry.reedysetfiles: + __missing__.diff
keywords: + patch
2014-12-07 20:49:29terry.reedycreate